var WDGT_VERSION = 1.1;

var toonpool = {};//general
toonpool.s = {};//slideshow
toonpool.c = {};//config
toonpool.mac = {};//Mac Kram
toonpool.win = {};//Win Kram

//Slideshow
toonpool.s.speed = 8000;
toonpool.s.timer = null;
toonpool.s.preloaded = null;
toonpool.s.pics = [];
toonpool.s.system = 'web';
toonpool.s.h = 130;
toonpool.s.w = 100;

toonpool.s.onclick = function(url) {
  if (window.widget) {
    window.widget.openURL(url);
    return false;
  }
  return true;
};

toonpool.s.init = function() {
  if (toonpool.c.version > WDGT_VERSION) {
    $('update').innerHTML = "<a href='"+toonpool.updateLink+"' onclick='return toonpool.s.onclick(this.href);'>New Version: Update!</a>";
  }
  clearTimeout(toonpool.s.timer);
  if (toonpool.s.pics.length == 0) {
    $('imageHolder').innerHTML = 'Sorry, no matching cartoons found.';
    return;
  }
  toonpool.s.preload();
  if (toonpool.c.slide == 'false') {
    $('imageHolder').innerHTML = toonpool.s.preloaded;
    return;
  }
  toonpool.s.timer = window.setTimeout(toonpool.s.showThumb,(toonpool.s.speed / 2 ));
};

toonpool.s.showThumb = function() {
  $('imageHolder').innerHTML = toonpool.s.preloaded;
  toonpool.s.preload();
  if (toonpool.s.preloaded != null) {
    toonpool.s.timer = window.setTimeout(toonpool.s.showThumb,toonpool.s.speed);
  } else {
    toonpool.s.timer = window.setTimeout(toonpool.init,toonpool.s.speed);
  }
};

toonpool.s.printLogo = function() {
  var t = Math.floor((toonpool.s.h - 90) / 2)+'px';
  var l = Math.floor((toonpool.s.w - 74) / 2)+'px';
  $('imageHolder').innerHTML = "<a href='http://www.toonpool.com/' onclick='return toonpool.s.onclick(this.href);'><img style='position:relative; top: "+t+"; left: "+l+"; border: none;' src='http://www.toonpool.com/misc/pics/general/gadgetloader.gif' alt='toonpool logo' /></a>";
};

toonpool.s.preload = function() {
  var tp = toonpool.s;
  if (tp.pics.length == 0) {
    tp.preloaded = null;
    return;
  }
  var p = tp.pics.shift();
  var r = 1;
  if (toonpool.c.fullsize == 'true') {
    r = Math.max(Math.max(p.height/500,p.width/500),1);
  }
  var t = Math.floor((toonpool.s.h - p.height/r) / 2)+'px';
  var l = Math.floor((toonpool.s.w - p.width/r) / 2)+'px';
  tp.preloaded = "<a href='"+p.href+"' onclick='return toonpool.s.onclick(this.href);'><img style='position:relative; top: "+t+"; left: "+l+"; border: none;' src='"+p.src+"' alt='"+p.title+"' /></a>";
};

//general
toonpool.init = function() {
  if (window.widget) {
    if (!toonpool.mac.infoButton) {
      toonpool.mac.infoButton = new AppleInfoButton($('appleInfoButton'),$('tp_front'),'black','black',toonpool.mac.openSettings);
      toonpool.mac.okButton= new AppleGlassButton($('appleOkButton'),'Done',toonpool.mac.okSettings);
      toonpool.mac.cancelButton= new AppleGlassButton($('appleCancelButton'),'Cancel',toonpool.mac.cancelSettings);
      window.widget.onhide = toonpool.mac.sleep;
      window.widget.onshow = toonpool.mac.wakeup;
    }
    toonpool.s.system = 'mac';
    toonpool.updateLink = 'http://www.toonpool.com/misc/plugins/cartoons.zip';
  }
  if (window.System && window.System.Gadget) {
    System.Gadget.settingsUI = 'settings.html';
    System.Gadget.onSettingsClosed = toonpool.win.closedSettings;
    toonpool.s.system = 'win';
    toonpool.updateLink = 'http://www.toonpool.com/misc/plugins/cartoons.gadget';
  }
  toonpool.c = toonpool.getSettings();
  toonpool.flipSize();
  toonpool.s.printLogo();
  ajax.doRequest('http://www.toonpool.com/misc/plugins/toonpool_gadget.php?system='+toonpool.s.system+'&callback='+encodeURIComponent('toonpool.s.init();')+'&content='+toonpool.c.content+'&userid='+toonpool.c.userid+'&fullsize='+toonpool.c.fullsize);
};

toonpool.saveSettings = function() {
  tp.saveSetting('content',$('set_content').options[$('set_content').selectedIndex].value);
  tp.saveSetting('slide',$('set_slide').checked+'');
  tp.saveSetting('user',$('set_user').value);
  tp.saveSetting('userid',$('set_userid').value);
  tp.saveSetting('fullsize',$('set_fullsize').checked+'');
};

toonpool.getSettings = function() {
  var ret = {};
  ret.content = tp.getSetting('content');
  ret.slide = tp.getSetting('slide');
  ret.user = tp.getSetting('user');
  ret.userid = tp.getSetting('userid');
  ret.fullsize = tp.getSetting('fullsize');

  return ret;
};

toonpool.printSettingTable = function() {
  var d = '';
  var s = {'Random':'Random','Newest':'Newest','Selected':'Selected','Top%20Rated':'Top Rated','Daily%20Toon':'Daily Toon','user':'by Artist'};

  d += "Collection:<br />";
  d += "<select size='1' id='set_content' style='margin-bottom:5px;' onchange='toonpool.checkSelectLogic(this);'>";
  for (var v in s) {
    d += "<option value='"+v+"'"+(v != toonpool.c.content ? "" : "selected='selected'")+">"+s[v]+"</option>";
  }
  d += "</select><br />";
  d += "<input type='text' size='12' value='"+toonpool.c.user+"' style='margin-bottom:5px; "+(toonpool.c.content != 'user' ? 'display:none;' : '')+"' id='set_user' onfocus='toonpool.artistInit();' onkeyup='toonpool.artistSearch();' /><br/>";
  d += "<input type='hidden' id='set_userid' value='"+toonpool.c.userid+"' />";
  d += "<div id='searchResult' style='display:none; margin-bottom:5px;'></div>";
  d += "<input type='checkbox'"+(toonpool.c.slide != 'false' ? " checked='checked'" : ' ')+" id='set_slide' onclick='toonpool.checkCheckLogic();' /><label for='set_slide'> Slideshow</label><br/>";
  d += "<input type='checkbox'"+(toonpool.c.fullsize != 'true' ? ' ' : " checked='checked'")+" id='set_fullsize' /><label for='set_fullsize'> Full Size</label>";
  d += "<a href='http://www.toonpool.com/' onclick='return toonpool.s.onclick(this.href);' title='visit toonpool.com!'><img id='backlink' src='pics/link.gif' alt='website' /></a>";

  $('backHolder').innerHTML = d;
};

toonpool.artistInit = function() {
  var p = $('set_user');
  if (p.value == 'Search Artist') {
    p.value = '';
  }
};

toonpool.artistSearch = function() {
  if (!ajax.activeCall) {
    ajax.doRequest('http://www.toonpool.com/calls/searchArtistAjax.php?search='+encodeURIComponent($('set_user').value)+'&max=10&artist=1&callback=toonpool.showArtist');
  }
};

toonpool.showArtist = function(a) {
  var d = "<select size='1' id='resultSelect' onchange='toonpool.selectArtist(this);' style='width:100px;'>";
  if (a.length > 0) {
    d += "<option value='0'>please select</option>";
    for (var i = 0; i < a.length; i++) {
      d += "<option value='"+a[i].hidden+"'>"+a[i].result+"</option>";
    }
  } else {
    d += "<option value='0'>no user found</option>";
  }
  d += "</select>";
  $('searchResult').innerHTML = d;
  $('searchResult').style.display = 'block';
};

toonpool.selectArtist = function(s) {
  if (s.selectedIndex == 0) {
    return;
  }
  $('set_user').value = s.options[s.selectedIndex].text;
  $('set_userid').value = s.options[s.selectedIndex].value;
  $('searchResult').innerHTML = '';
  $('searchResult').style.display = 'none';
};

toonpool.checkSelectLogic = function(s) {
  var v = s.options[s.selectedIndex].value;
  if (v == 'Daily%20Toon') {
    $('set_slide').checked = false;
  }
  if (v == 'user') {
    $('set_user').style.display = '';
    $('set_user').value = 'Search Artist';
  } else {
    $('set_user').style.display = 'none';
    $('searchResult').innerHTML = '';
    $('searchResult').style.display = 'none';
  }
};

toonpool.checkCheckLogic = function() {
  if ($('set_slide').checked === true && $('set_content').options[$('set_content').selectedIndex].value == 'Daily%20Toon') {
    $('set_content').options[0].selected = true;
  }
};

toonpool.flipSize = function() {
  if (toonpool.c.fullsize == 'true') {
    toonpool.s.h = 500;
    toonpool.s.w = 500;
    $('toonpool_body').style.height = 565+'px';
    $('toonpool_body').style.width = 565+'px';
    $('tp_front').className = 'tp_front_5';
    $('imageHolder').className = 'imageHolder_5';
    if (window.widget) {
      window.resizeTo(565, 565);
      $('tp_front').style.background = "url(pics/front_5.png) no-repeat transparent";
      $('appleInfoButton').style.top = '16px';
      $('appleInfoButton').style.right = '34px';
    }
    if (window.System && window.System.Gadget) {
      System.Gadget.background = 'pics/front_5.png';
    }
  } else {
    toonpool.s.h = 130;
    toonpool.s.w = 100;
    $('toonpool_body').style.height = 180+'px';
    $('toonpool_body').style.width = 150+'px';
    $('tp_front').className = 'tp_front_t';
    $('imageHolder').className = 'imageHolder_t';
    if (window.widget) {
      window.resizeTo(150, 180);
      $('tp_front').style.background = "url(pics/front_t.png) no-repeat transparent";
      $('appleInfoButton').style.top = '8px';
      $('appleInfoButton').style.right = '25px';
    }
    if (window.System && window.System.Gadget) {
      System.Gadget.background = 'pics/front_t.png';
    }
  }
};

//mac
toonpool.mac.openSettings = function() {
  toonpool.printSettingTable();
  widget.prepareForTransition('ToBack');
  $('tp_front').style.display = 'none';
  $('tp_back').style.display = 'block';
  widget.performTransition();
};

toonpool.mac.okSettings = function() {
  toonpool.saveSettings();
  toonpool.c = toonpool.getSettings();
  toonpool.init();
  toonpool.mac.cancelSettings();
};

toonpool.mac.cancelSettings = function() {
  widget.prepareForTransition('ToFront');
  $('tp_front').style.display = 'block';
  $('tp_back').style.display = 'none';
  widget.performTransition();
};

toonpool.mac.sleep = function() {
  window.clearTimeout(toonpool.s.timer);
  toonpool.s.preloaded = null;
  toonpool.s.pics = [];
};

toonpool.mac.wakeup = function() {
  toonpool.init();
};

//win
toonpool.win.closeSettings = function(e) {
  if (e.closeAction == e.Action.commit) {//Ok
    toonpool.saveSettings();
  } else {//Cancel
  }
  e.cancel = false;
};

toonpool.win.closedSettings = function(e) {
  if (e.closeAction == e.Action.commit) {//Ok
    toonpool.init();
  } else {//Cancel
  }
};

toonpool.win.settingsInit = function() {
  System.Gadget.onSettingsClosing = toonpool.win.closeSettings;
  toonpool.c = toonpool.getSettings();
  toonpool.printSettingTable();
};

//helper
function $(id) {
  return document.getElementById(id);
}